#include "stm32f10x.h"
#include "disp.h"
#include "color.h"

//unsigned int backcolor;
//unsigned int textcolor;

const uint16_t pot10[4] ={10,100,1000,10000};

void ubi2dec( uint16_t val,  char *strg, uint8_t nzero);
void ubi2dec( uint16_t val,  char *strg, uint8_t nzero)
/*
  convert unsigned int16 value to a character string
  stringlength has to be 6 character 65536 + the final 0
  
  if nzero==0, no leading zeros
  if nzero==1, with leading zeros  
*/
{
  uint8_t dec,idx=4,odx=0;
  
  do
  {
    idx--;
    for (dec=0; val>=pot10[idx]; val-=pot10[idx])
    {
      dec++;
    }
    nzero+=dec;
    if (nzero) strg[odx++]='0'+dec;
  } while(idx);
  strg[odx++]='0'+val;
  strg[odx]=0;
}


// 
void InitDevs (void)
{
	RCC->APB2ENR |= RCC_APB2ENR_IOPAEN; // Enable Clock Tact for PORTA
	RCC->APB2ENR |= RCC_APB2ENR_IOPCEN; // Enable Clock Tact for PORTC

	RCC->APB2ENR |= RCC_APB2ENR_AFIOEN; // Alternate Enable Clock Tacting
	   
	Set_PortC_Pin_1_output; //CS
	Set_PortC_Pin_2_output; //RST
	Set_PortC_Pin_3_output; //RS

	Set_PortC_Pin_8_output;
	Set_PortC_Pin_9_output;

	AFIO->MAPR   &= ~0x1; //Selecrt SPI on ports PA4, PA5, PA6, PA7

	GPIOA->CRL = 0x44444444; //Set all ports to reset state
	GPIOA->CRH = 0x44444444;

	GPIOA->CRL   &= ~(0x0FUL << 28);	   //PA7 clear
	GPIOA->CRL   &= ~(0x0FUL << 20);	   //PA5 clear
	GPIOA->CRL   |=  (0x0BUL  << 28);	   //PA7 alternate output push-pull
	GPIOA->CRL   |=  (0x0BUL  << 20); 	   //PA5 alternate output push-pull

	RCC->APB2ENR |= RCC_APB2ENR_SPI1EN;
}

void SPIinit (void)
{
	//SPI1->CR1 &= ~0xFFFF;
	//SPI1->CR1 |= (0x1);				//CPHA = 1
	//SPI1->CR1 &= ~(0x1 << 1);		//CPOL = 0
	SPI1->CR1 |= SPI_CR1_MSTR;;		//MSTR = 1
	//SPI1->CR1 |= (0x2 << 3);		//BR[2:0] = 001
	//SPI1->CR1 &= ~(0x1 << 7);		//LSBFIRST = 0
	//SPI1->CR1 &= ~(0x1 << 9);		//SSM = 0
	//SPI1->CR1 |= SPI_CR1_DFF;			//DFF = 1 // 16 Bit

	//SPI1->CR1 &= ~(0x1 << 10);		//RXONLY = 0
        SPI1->CR1 |= SPI_CR1_BIDIOE;            //BIDIOE = 1 //Only transmit
	SPI1->CR1 |= SPI_CR1_BIDIMODE;		//BIDIMODE = 1 //One wire mode
	SPI1->CR1 |= SPI_CR1_SSI;			//	  
  SPI1->CR1 |= SPI_CR1_SSM;			
	
	SPI1->CR1 |= SPI_CR1_BR_0; // 6 MHz

	//SPI1->CR2 |= (0x1 << 2);		//SSOE = 1

	SPI1->CR1 |= SPI_CR1_SPE; 		//SPE = 1 
}

void print_str(uint8_t x, uint8_t y, char *txt)
{
  uint8_t i=0;
  while (txt[i]!=0)
  {
    put_char(x+i*CHAR_W,y,txt[i],1);
    i++;
  }
}

int main (void)
{
  uint16_t cnt;
  char nr[7];
  
  char txt[]=". Zeile L2F\0";

	InitDevs();
	SPIinit();
	lcd_init_c();

  BlueLedOn;     

  fill_screen(RGB_YELLOW);
  delay_ms(3000);
	fill_screen(RGB_RED);
  delay_ms(3000);
	fill_screen(RGB_WHITE);
  delay_ms(3000);
  BlueLedOff;
	
	cnt = 0;
        
  while (1)
	{     
		GreenLedOn;
		delay_ms(500);
		
	 ubi2dec(cnt,nr,1);
    print_str(0       ,(cnt*CHAR_H) % (12*14),nr);
    print_str(5*CHAR_W,(cnt*CHAR_H) % (12*14),txt);

		cnt++;
		
		GreenLedOff;
		delay_ms(500);
	}
	


}
